/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.2 on 2010-05-19 09:20:17,
 any modifications will be overwritten.
 ==============================================================
 */

package org.sonatype.nexus.plugins.crowd.config.model.v1_0_0;

/**
 * The root element of Nexus Crowd Plugin configuration.
 * 
 * @version $Revision$ $Date$
 */
public class Configuration
    implements java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * The version of the persisted model.
     */
    private String version;

    /**
     * The application name registered with Crowd.
     */
    private String applicationName;

    /**
     * The application password registered with Crowd.
     */
    private String applicationPassword;

    /**
     * The Crowd Server URL.
     */
    private String crowdServerUrl;

    /**
     * The Crowd session validation interval.
     */
    private int sessionValidationInterval = 0;

    /**
     * If true, Crowd groups will be used as the source of Nexus
     * role names.
     */
    private boolean useGroups = false;

    /**
     * Field extraCrowdProperties.
     */
    private java.util.List/*<Property>*/ extraCrowdProperties;

    /**
     * Field modelEncoding.
     */
    private String modelEncoding = "UTF-8";


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addExtraCrowdProperty.
     * 
     * @param property
     */
    public void addExtraCrowdProperty( Property property )
    {
        getExtraCrowdProperties().add( property );
    } //-- void addExtraCrowdProperty( Property )

    /**
     * Get the application name registered with Crowd.
     * 
     * @return String
     */
    public String getApplicationName()
    {
        return this.applicationName;
    } //-- String getApplicationName()

    /**
     * Get the application password registered with Crowd.
     * 
     * @return String
     */
    public String getApplicationPassword()
    {
        return this.applicationPassword;
    } //-- String getApplicationPassword()

    /**
     * Get the Crowd Server URL.
     * 
     * @return String
     */
    public String getCrowdServerUrl()
    {
        return this.crowdServerUrl;
    } //-- String getCrowdServerUrl()

    /**
     * Method getExtraCrowdProperties.
     * 
     * @return List
     */
    public java.util.List/*<Property>*/ getExtraCrowdProperties()
    {
        if ( this.extraCrowdProperties == null )
        {
            this.extraCrowdProperties = new java.util.ArrayList/*<Property>*/();
        }

        return this.extraCrowdProperties;
    } //-- java.util.List/*<Property>*/ getExtraCrowdProperties()

    /**
     * Get the modelEncoding field.
     * 
     * @return String
     */
    public String getModelEncoding()
    {
        return this.modelEncoding;
    } //-- String getModelEncoding()

    /**
     * Get the Crowd session validation interval.
     * 
     * @return int
     */
    public int getSessionValidationInterval()
    {
        return this.sessionValidationInterval;
    } //-- int getSessionValidationInterval()

    /**
     * Get the version of the persisted model.
     * 
     * @return String
     */
    public String getVersion()
    {
        return this.version;
    } //-- String getVersion()

    /**
     * Get if true, Crowd groups will be used as the source of
     * Nexus role names.
     * 
     * @return boolean
     */
    public boolean isUseGroups()
    {
        return this.useGroups;
    } //-- boolean isUseGroups()

    /**
     * Method removeExtraCrowdProperty.
     * 
     * @param property
     */
    public void removeExtraCrowdProperty( Property property )
    {
        getExtraCrowdProperties().remove( property );
    } //-- void removeExtraCrowdProperty( Property )

    /**
     * Set the application name registered with Crowd.
     * 
     * @param applicationName
     */
    public void setApplicationName( String applicationName )
    {
        this.applicationName = applicationName;
    } //-- void setApplicationName( String )

    /**
     * Set the application password registered with Crowd.
     * 
     * @param applicationPassword
     */
    public void setApplicationPassword( String applicationPassword )
    {
        this.applicationPassword = applicationPassword;
    } //-- void setApplicationPassword( String )

    /**
     * Set the Crowd Server URL.
     * 
     * @param crowdServerUrl
     */
    public void setCrowdServerUrl( String crowdServerUrl )
    {
        this.crowdServerUrl = crowdServerUrl;
    } //-- void setCrowdServerUrl( String )

    /**
     * Set a list of additional properties for the Crowd client.
     * 
     * @param extraCrowdProperties
     */
    public void setExtraCrowdProperties( java.util.List/*<Property>*/ extraCrowdProperties )
    {
        this.extraCrowdProperties = extraCrowdProperties;
    } //-- void setExtraCrowdProperties( java.util.List )

    /**
     * Set the modelEncoding field.
     * 
     * @param modelEncoding
     */
    public void setModelEncoding( String modelEncoding )
    {
        this.modelEncoding = modelEncoding;
    } //-- void setModelEncoding( String )

    /**
     * Set the Crowd session validation interval.
     * 
     * @param sessionValidationInterval
     */
    public void setSessionValidationInterval( int sessionValidationInterval )
    {
        this.sessionValidationInterval = sessionValidationInterval;
    } //-- void setSessionValidationInterval( int )

    /**
     * Set if true, Crowd groups will be used as the source of
     * Nexus role names.
     * 
     * @param useGroups
     */
    public void setUseGroups( boolean useGroups )
    {
        this.useGroups = useGroups;
    } //-- void setUseGroups( boolean )

    /**
     * Set the version of the persisted model.
     * 
     * @param version
     */
    public void setVersion( String version )
    {
        this.version = version;
    } //-- void setVersion( String )

    
    public static final String MODEL_VERSION = "1.0.0";
    public static final int DEFAULT_SESSION_VALIDATION_INTERVAL = 30;

    
    public java.util.Properties getCrowdClientProperties() {
        java.util.Properties props = new java.util.Properties();
        props.setProperty(com.atlassian.crowd.integration.Constants.PROPERTIES_FILE_APPLICATION_NAME, applicationName);
        props.setProperty(com.atlassian.crowd.integration.Constants.PROPERTIES_FILE_APPLICATION_PASSWORD, applicationPassword);
        props.setProperty(com.atlassian.crowd.integration.Constants.PROPERTIES_FILE_SECURITY_SERVER_URL, crowdServerUrl);
        props.setProperty(com.atlassian.crowd.integration.Constants.PROPERTIES_FILE_SESSIONKEY_VALIDATIONINTERVAL, Integer.toString(sessionValidationInterval));
        if (extraCrowdProperties != null) {
            for (java.util.Iterator<Property> it = extraCrowdProperties.iterator(); it.hasNext();) {
                Property prop = it.next();
                props.setProperty(prop.getKey(), prop.getValue());
            }
        }
        return props;
    }

}
